clc
close all
clear all
y=load('y2_y101.dat'); %load the first 100 measurament obtained from time 2 to time 101
y=[0,y]; % to have that y(i) indicates the measurament performed at time i 
k=101; %current time


% state estimation based on noisy measurement
% process model parameters: x(t)=ax(t-1)^2+bx(t-1)+c+omega_proc
a=0.01;
b=1;
c=0.001;
std_omega_proc=0.001;

%measurament model parameters: z(t)=x(t)+omega_meas
std_omega_meas=0.05;

% particles sampling

Nsamp = 1000;

% initialize  weights (w(1,:)) and particles x(1,:)
%initial weights
w(1,:) = ones(Nsamp,1)/Nsamp;
%initial particles
x(1,:)=rand(1,Nsamp)*0.05; %from uniform [0,0.005]
%mean of initial particles
x_mean(1)=x(1,:)*w(1,:)';

%%

% start the prediction-updating cycle

for t=2:k
    %prediction stage

    % Estimate x(t,:)
    %   x(t,j) indicates the degradation of particle i at time t
    % ... to be filled ...
    
        
    %update stage
    
    % Estimate w(t,:) using the measurament at time t
    %   w(t,j) indicates the weight of particle j at time t
    % ... to be filled ...
    
    
    % estimate the weighted mean and standard deviation of the particles
    % ... to be filled ...
    
    % estimate degradation state mean {x_mean(t)} and 5 percentile {x5(t)} and 95 percentile {x95(t)} 
    % (hint: order the particles --> order the weights --> cumulative sum of the weights --> percentiles...)
    % ... to be filled ...
    
    
end

%%
% Plot the results 
plot(x)
title('evolution of the particles')
figure
plot(w)
title('evolution of the particle weight')

figure
title('weighted mean and standard deviation of the particles')
x_axis = 1:numel(x_mean);
curve1 = x_mean + x_std;
curve2 = x_mean - x_std;
area = [x_axis, fliplr(x_axis)];
inBetween = [curve1, fliplr(curve2)];
fill(area, inBetween, 'g');
hold on;
plot(x_axis, x_mean, 'r', 'LineWidth', 2);

figure
plot(x_mean)
hold on
plot(x5);
plot(x95);
title('degradation state mean and percentiles')
hold on
load x_true
plot(x_true(1:401),'g')
plot(2:k,y(2:k),'r')
title('degradation state mean and standard deviation')
legend('recon mean','perc 5','perc95','true','meas')
